// VCPGDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCPG.h"
#include "VCPGDlg.h"
#include <afxdlgs.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct _PGSI
{
    int         iFreq;
	int			iFreqMode;
	int			iPodVolt[6];
	int			iPGVRecord;
    int         iRes[119];
} PGSI, FAR *LPPGSI;

typedef	BOOL (__stdcall *PUPGINITEX)( long lModel, long lSlot );
typedef long (__stdcall *PUPGGETSTATUS)(void);
typedef BOOL (__stdcall *PPGINTERFACENAME)( long lDevice, LPBYTE lpbNull, long lItem, LPCSTR szData, long lSize );
typedef BOOL (__stdcall *PUPGADJVOLT)( long lGroup, long lMilliVolt );
typedef long (__stdcall *PUPGSTART)( LPCSTR szFileName, long lFileType, LPPGSI lpPgsi );
typedef BOOL (__stdcall *PUPGSTOP)(void);
typedef BOOL (__stdcall *PUPGSHUTDOWN)(void);
typedef BOOL (__stdcall *PUPGKEYEVENT)(void);

CFileDialog			*pcfd = NULL;
HMODULE				ghmPG = NULL;
PUPGINITEX			pupgInitEx;
PUPGGETSTATUS		pupgGetStatus;
PPGINTERFACENAME	ppgInterfaceName;
PUPGADJVOLT			pupgAdjVolt;
PUPGSTART			pupgStart;
PUPGSTOP			pupgStop;
PUPGSHUTDOWN		pupgShutdown;
PUPGKEYEVENT		pupgKeyEvent;
long				glDevice;

/////////////////////////////////////////////////////////////////////////////
// CVCPGDlg dialog

CVCPGDlg::CVCPGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCPGDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCPGDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVCPGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCPGDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCPGDlg, CDialog)
	//{{AFX_MSG_MAP(CVCPGDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GETHARDWARE, OnGetHardware)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_SHUTDOWN, OnShutdown)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCPGDlg message handlers

BOOL CVCPGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	glDevice = -1;
	if( ( ghmPG = LoadLibrary( "PgRun.dll" ) ) == NULL )
	{
		MessageBox( "Can NOT Load PGRUN.DLL", NULL, MB_ICONERROR );
		( (CButton *)GetDlgItem( IDC_GETHARDWARE ) )->EnableWindow( false );
	}
	else
	{
		pupgInitEx			= (PUPGINITEX)GetProcAddress( ghmPG, "upgInitEx" );
		pupgGetStatus		= (PUPGGETSTATUS)GetProcAddress( ghmPG, "upgGetStatus" );
		ppgInterfaceName	= (PPGINTERFACENAME)GetProcAddress( ghmPG, "pgInterfaceName" );
		pupgAdjVolt			= (PUPGADJVOLT)GetProcAddress( ghmPG, "upgAdjVolt" );
		pupgStart			= (PUPGSTART)GetProcAddress( ghmPG, "upgStart" );
		pupgStop			= (PUPGSTOP)GetProcAddress( ghmPG, "upgStop" );
		pupgShutdown		= (PUPGSHUTDOWN)GetProcAddress( ghmPG, "upgShutdown" );
		pupgKeyEvent		= (PUPGKEYEVENT)GetProcAddress( ghmPG, "upgKeyEvent" );
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCPGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCPGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCPGDlg::OnGetHardware() 
{
	// TODO: Add your control notification handler code here
	long		i, ID;
	char		sz[64];

	if( pupgInitEx( 0, 0 ) )
	{
		i = pupgGetStatus();
		ID = i & 0xFF;
		glDevice = (long)HIWORD(i);
		if( ID <= 0 && glDevice != -1 )
		{
			pupgShutdown();
			glDevice = -1;
		}
		if( glDevice == -1 )
		{
			MessageBox( "No Hardware!" );
			return;
		}
		ppgInterfaceName( glDevice, NULL, 0, sz, sizeof(sz) );
		SetDlgItemText( IDC_MODEL, sz );
		( (CButton *)GetDlgItem( IDC_GETHARDWARE ) )->EnableWindow( false );
		( (CButton *)GetDlgItem( IDC_START ) )->EnableWindow( true );
		( (CButton *)GetDlgItem( IDC_STOP ) )->EnableWindow( true );
		( (CButton *)GetDlgItem( IDC_SHUTDOWN ) )->EnableWindow( true );
		GetDlgItem( IDC_RED )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_GRAY )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_GREEN )->ShowWindow( SW_SHOW );
	}
}

void CVCPGDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	BOOL	fRet;
	long	lFileType;
	PGSI	pgsi;
	CString	str, str1;

	GetDlgItemText( IDC_FILENAME, str );
	str1 = str.Right(4);
	str1.MakeUpper();
	if( str1.Compare( ".PGW" ) == 0 )
		lFileType = 0;
	else if( str1.Compare( ".PGV" ) == 0 )
		lFileType = 1;
	else
	{
		MessageBox( "Unknown file type!" );
		return;
	}
    pupgAdjVolt( 0, 5000 );                 // Pod A, B
    pupgAdjVolt( 1, 5000 );					// Pod C, D, E
	ZeroMemory( (LPVOID)&pgsi, sizeof(PGSI) );
    pgsi.iPodVolt[0] = 5000;				// Same as upgAdjVolt 0, 5000
    pgsi.iPodVolt[1] = 5000;				// Same as upgAdjVolt 1, 5000
    fRet = pupgStart( LPCSTR(str), lFileType, &pgsi );
	GetDlgItem( IDC_RED )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GREEN )->ShowWindow( SW_SHOW );
	switch( fRet )
	{
        case 0:                      // Normal
			( (CButton *)GetDlgItem( IDC_BROWSE ) )->EnableWindow( false );
			( (CButton *)GetDlgItem( IDC_START ) )->EnableWindow( false );
			GetDlgItem( IDC_RED )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_GREEN )->ShowWindow( SW_HIDE );
			break;

        case 1:
            MessageBox( "File Not Found." );
			break;

        case 2:
            MessageBox( "File Reading Error." );
			break;

        case 3:
            MessageBox( "File Type Error or Not Support." );
			break;

        case 4:
            MessageBox( "File Format Error." );
			break;

        case 5:
            MessageBox( "File Version is too old." );
			break;

        case 6:
            MessageBox( "Memory Not Enough." );
			break;

        case 7:
            MessageBox( "Singal Name confuse in PGV file." );			// PGVɮ״yzTWٽĬ 
			break;

        case 8:
            MessageBox( "Too many channel to be defined." );			// ϥγqDƹLh
			break;

        case 9:
            MessageBox( "PGV Time Stamp Error." );						// PGV Time Stamp ~
			break;

        case 10:
            MessageBox( "Can't use Time Stamp and INTERVAL or FREQUENCY at same time." );
			break;

        case 11:
            MessageBox( "No Signal Name in PGV File" );
			break;

        case 12:
            MessageBox( "Over PG hardware memory depth." );
			break;

        case 13:
            MessageBox( "No Time Stamp in Time Stamp mode." );
			break;

        case 14:
            MessageBox( "No channel assigned for some signal" );
			break;

        case 99:
            MessageBox( "No Hardware" );								// SupgInitAάO䤣w˸m
			break;

        case 0x8001:
            if( MessageBox( "Warning: Use close frequency for system clock. Run(Y/N)", NULL, MB_YESNO ) == IDYES )
			{
				( (CButton *)GetDlgItem( IDC_BROWSE ) )->EnableWindow( false );
				( (CButton *)GetDlgItem( IDC_START ) )->EnableWindow( false );
				GetDlgItem( IDC_RED )->ShowWindow( SW_SHOW );
				GetDlgItem( IDC_GREEN )->ShowWindow( SW_HIDE );
			}
			else
			{
                pupgStop();
			}
			break;

        default:
            MessageBox( "Critical Error." );
			break;
	}
}

void CVCPGDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
    pupgStop();
	( (CButton *)GetDlgItem( IDC_BROWSE ) )->EnableWindow( true );
	( (CButton *)GetDlgItem( IDC_START ) )->EnableWindow( true );
	GetDlgItem( IDC_RED )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GREEN )->ShowWindow( SW_SHOW );
}

void CVCPGDlg::OnShutdown() 
{
	// TODO: Add your control notification handler code here
	OnStop();
    pupgShutdown();
	( (CButton *)GetDlgItem( IDC_GETHARDWARE ) )->EnableWindow( true );
	( (CButton *)GetDlgItem( IDC_START ) )->EnableWindow( false );
	( (CButton *)GetDlgItem( IDC_STOP ) )->EnableWindow( false );
	( (CButton *)GetDlgItem( IDC_SHUTDOWN ) )->EnableWindow( false );
	SetDlgItemText( IDC_MODEL, "" );
	GetDlgItem( IDC_RED )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GRAY )->ShowWindow( SW_SHOW );
	GetDlgItem( IDC_GREEN )->ShowWindow( SW_HIDE );
    glDevice = -1;
}

void CVCPGDlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
    char	szFile[2048] = "*.pgw;*.pgv";		// maximum common dialog buffer size
    char	szFilter[] = "PG Waveform Files(*.pgw;*.pgv)|*.pgw;*.pgv|All Files(*.*)|*.*||";
	CString	str;

	CFileDialog dlg( TRUE, NULL, szFile, OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT, szFilter );

	// Modify OPENFILENAME members directly to point to szFile
	dlg.DoModal();
	str = dlg.GetPathName();
	SetDlgItemText( IDC_FILENAME, LPCSTR(str) );
}

void CVCPGDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnClose();
}
